export function getVal(x) {
  return x && x.getValue ? x.getValue() : x;
}

export class Var {
  constructor(value) {
    if (typeof value === "function") {
      this._updateFunc = value;
      this._value = this._updateFunc(0);
    } else {
      this._value = value;
      this._updateFunc = null;
    }
  }

  updateFunc(func) {
    this._updateFunc = func;
  }

  update(t) {
    if (this._updateFunc) {
      this._value = this._updateFunc(t);
    }
  }

  getValue() {
    return this._value;
  }
}
